/***** shustring.h ************************************************
 * Description: Header file for shustring program
 * Author: Bernhard Haubold, bernhard.haubold@fh-weihenstephan.de
 * File created on Mon Feb 21 14:40:13 2005.
 *****************************************************************/
#define NAMELENGTH 30
/* object for collecting various results of shustring computations */
typedef struct shustringResult{
  char **names;             /* sequence names */
  Shustring **shustrings;   /* array of shustring lists, one list for each sequence */
  int numStrings;           /* number of input strings */
  int *numShustrings;       /* number of shustrings per input list */ 
  int *strLengths;          /* array of input string lengths */
  short *coverIndex;        /* input string covered by a shustring? */
  int numCovered;           /* number of sequences covered by shustrings */
  unsigned int isUpper : 1; /* uppercase */
} ShustringResult;

int stringDepth(SUFFIX_TREE tree, STREE_NODE node);
int findGlobalShustrings(SUFFIX_TREE tree, STREE_NODE node);
int printShustring(SUFFIX_TREE tree, STREE_NODE node);
int compareShustrings(const void *, const void *);
int collectLocalShustrings(SUFFIX_TREE tree, STREE_NODE node);
void outputHash(ShustringResult *result, Args args);
void runHash(Args args);
void setLocalIndex(SUFFIX_TREE tree);
void computeSizeRange(Shustring **shustringArray, int arraySize, Range *range);
void setArgs(Args arguments);
Shustring **createShustringArray(SUFFIX_TREE tree, Shustring **shustringArray, int strid);
int printLocalShustrings(SUFFIX_TREE tree, STREE_NODE node);
void outputShustrings(SUFFIX_TREE tree);
